
-- This function takes an item ID value (eg. 1879230113) and returns an instance of the item
-- This function still works - U32 23/02/2022
function GetItemFromID(itemID)
	if itemID == nil then return end;
	local itemHex = TO_HEX(itemID);
	local cItemInspect = Turbine.UI.Lotro.Quickslot();
	cItemInspect:SetSize(1,1);
	cItemInspect:SetVisible(false);
	local function SetItemShortcut() 	-- PCALL THIS incase item does not exist
		cItemInspect:SetShortcut(Turbine.UI.Lotro.Shortcut(Turbine.UI.Lotro.ShortcutType.Item, "0x0,0x" .. itemHex));
	end
	if pcall(SetItemShortcut) then
		SetItemShortcut();
		local item = cItemInspect:GetShortcut():GetItem();
		cItemInspect = nil;
		return item;
	end
	cItemInspect = nil;
end

function NewItemInfo(itemID)
	--Decode.Log.Debug(itemID);
	if itemID == nil then return end;

	local cItemInfo = Turbine.UI.Lotro.ItemInfoControl();
	cItemInfo:SetSize(36,36);
	cItemInfo:SetAllowDrop(false);
	cItemInfo:SetVisible(true);
	cItemInfo:SetItemInfo(GetItemFromID(itemID):GetItemInfo());
	cItemInfo:SetQuantity(1);

	return cItemInfo;
end

function print(MESSAGE)
	if MESSAGE == nil then return end;
	Turbine.Shell.WriteLine("<rgb=#FF6666>" .. tostring(MESSAGE) .. "</rgb>");
end

-- Converts an RGB color (0 - 255) number to hex. ---------------------------------
function TO_HEX(IN)
	local B,K,OUT,I,D=16,"0123456789ABCDEF","",0,0;

		if IN == 0 or IN == "0" then
			return "00";
		end

		while IN>0 do
		I=I+1
		IN,D=math.floor(IN/B),math.mod(IN,B)+1
		OUT=string.sub(K,D,D)..OUT
	end
	if string.len(OUT) == 1 then OUT = "0" .. OUT end;
	return OUT
end

function dump(o)
    if type(o) == 'table' then
        local s = '{\n'
        for k,v in pairs(o) do
                if type(k) ~= 'number' then k = '"'..k..'"' end
                s = s .. '['..k..'] = ' .. dump(v) .. '\n'
        end
        return s .. '}\n'
    else
        return tostring(o)
    end
end